/*
 * main.c
 *
 *  Created on: 14.05.2018
 *      Author: .223rem
 */
#include <stdio.h>

int main()
{
	uint32_t loopCounter;

	while(1)
	{
		test_function_one(loopCounter,~loopCounter);
		test_function_two(loopCounter,~loopCounter);
		test_function_three(loopCounter,~loopCounter);

		loopCounter++;
	}

	return 0;
}
/* The prototype shows it is a naked function - in effect this is just an
assembly function. */
void HardFault_Handler( void ) __attribute__( ( naked ) );

void HardFault_Handler(void)
{
        /*
         * Get the appropriate stack pointer, depending on the current core mode it
         * will be Main Stack or Process Stack
         */

    __asm__ __volatile__ (
        " tst lr, #4                                                \n"
        " ite eq                                                    \n"
        " mrseq r0, MSP                                             \n"
        " mrsne r0, PSP                                             \n"
        " b ReadStackedData                                         \n"
    );

}

/**
 * ReadStackedData:
 * This is called from the HardFault_Handler.
 */
void ReadStackedData(uint32_t *hardfault_args)
{
        volatile uint32_t stacked_r0 ;
        volatile uint32_t stacked_r1 ;
        volatile uint32_t stacked_r2 ;
        volatile uint32_t stacked_r3 ;
        volatile uint32_t stacked_r12 ;
        volatile uint32_t stacked_lr ;
        volatile uint32_t stacked_pc ;
        volatile uint32_t stacked_psr ;

        //read register values from the stack into the local variables
        stacked_r0  =  hardfault_args[0] ;
        stacked_r1  =  hardfault_args[1] ;
        stacked_r2  =  hardfault_args[2] ;
        stacked_r3  =  hardfault_args[3] ;
        stacked_r12 =  hardfault_args[4] ;
        stacked_lr  =  hardfault_args[5] ;
        stacked_pc  =  hardfault_args[6] ;
        stacked_psr =  hardfault_args[7] ;

        (void)stacked_r0;
        (void)stacked_r1;
        (void)stacked_r2;
        (void)stacked_r3;
        (void)stacked_r12;
        (void)stacked_lr;
        (void)stacked_pc;
        (void)stacked_psr;

        //Now transmit, print, save the stacked data//

        while(1)
        {
        	//wait for watchdog
        }
}
